-#!/bin/sh
-. /etc/functions.sh
-include network
-scan_interfaces
-
-# The following is to automatically configure the DHCP settings
-# based on config settings. Feel free to replace all this crap
-# with a simple "dnsmasq" and manage everything via the
-# /etc/dnsmasq.conf config file
-
-[ -f /etc/dnsmasq.conf ] || exit
-
-args=""
-iface=lan
-config_get ifname "$iface" ifname
-
-dhcp_enable="${dhcp_enable:-1}"
-dhcp_start="${dhcp_start:-100}"
-dhcp_num="${dhcp_num:-50}"
-dhcp_lease="${dhcp_lease:-12h}"
-
-# if dhcp_enable is unset and there is a dhcp server on the network already, default to dhcp_enable=0
-[ -z "$dhcp_enable" ] && udhcpc -n -q -R -s /bin/true -i $ifname >&- && dhcp_enable="${dhcp_enable:-0}"
-
-# dhcp_enable=0 disables the dhcp server
-(
- [ -z "$dhcp_enable" -o "$dhcp_enable" -eq 1 ] && {
- # no existing DHCP server?
-
- # calculate settings
- config_get ipaddr "$iface" ipaddr
- config_get netmask "$iface" netmask
- eval $(ipcalc $ipaddr $netmask ${dhcp_start:-100} ${dhcp_num:-150})
-
- # and pass the args via config parser defines
- echo "@define dhcp_enable 1"
- echo "@define netmask $NETMASK"
- echo "@define start $START"
- echo "@define end $END"
- echo "@define lease ${dhcp_lease:-12h}"
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2007 OpenWrt.org
+
+START=60
+DNS_SERVERS=""
+
+dhcp_calc() {
+ local ip="$1"
+ local res=0
+
+ while [ -n "$ip" ]; do
+ part="${ip%%.*}"
+ res="$(($res * 256))"
+ res="$(($res + $part))"
+ [ "${ip%.*}" != "$ip" ] && ip="${ip#*.}" || ip=
+ done
+ echo "$res"
+}
+
+append_bool() {
+ local section="$1"
+ local option="$2"
+ local value="$3"
+ local _loctmp
+ config_get_bool _loctmp "$section" "$option"
+ [ "$_loctmp" -gt 0 ] && append args "$value"
+}
+
+append_parm() {
+ local section="$1"
+ local option="$2"
+ local switch="$3"
+ local _loctmp
+ config_get _loctmp "$section" "$option"
+ [ -z "$_loctmp" ] && return 0
+ append args "$switch $_loctmp"
+}
+
+dnsmasq() {
+ local cfg="$1"
+ append_bool "$cfg" authoritative "-K"
+ append_bool "$cfg" nodaemon "-d"
+ append_bool "$cfg" domainneeded "-D"
+ append_bool "$cfg" filterwin2k "-f"
+ append_bool "$cfg" nohosts "-h"
+ append_bool "$cfg" nonegcache "-N"
+ append_bool "$cfg" strictorder "-o"
+ append_bool "$cfg" logqueries "-q"
+ append_bool "$cfg" noresolv "-R"
+ append_bool "$cfg" localise_queries "-y"
+ append_bool "$cfg" readethers "-Z"
+ append_bool "$cfg" dbus "-1"
+ append_bool "$cfg" boguspriv "-b"
+ append_bool "$cfg" expandhosts "-E"
+
+ append_parm "$cfg" dnsforwardmax "-0"
+ append_parm "$cfg" port "-p"
+ append_parm "$cfg" ednspacket_max "-P"
+ append_parm "$cfg" dhcpleasemax "-X"
+ append_parm "$cfg" "addnhosts" "-H"
+ append_parm "$cfg" "queryport" "-Q"
+ append_parm "$cfg" "domain" "-s"
+ append_parm "$cfg" "local" "-S"
+ append_parm "$cfg" "leasefile" "-l"
+ append_parm "$cfg" "resolvfile" "-r"
+
+ config_get leasefile $cfg leasefile
+ [ -e "$leasefile" ] || touch "$leasefile"
+}
+
+dhcp_subscrid_add() {
+ local cfg="$1"
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || return 0
+
+ config_get subscriberid "$cfg" subscriberid
+ [ -n "$subscriberid" ] || return 0
+
+ append args "--dhcp-subscrid=$name,$subscriberid"
+
+ dhcp_option_add "$cfg" "$name"
+}
+
+dhcp_remoteid_add() {
+ local cfg="$1"
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || return 0
+
+ config_get remoteid "$cfg" remoteid
+ [ -n "$remoteid" ] || return 0
+
+ append args "--dhcp-remoteid=$name,$remoteid"
+
+ dhcp_option_add "$cfg" "$name"
+}
+
+dhcp_circuitid_add() {
+ local cfg="$1"
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || return 0
+
+ config_get circuitid "$cfg" circuitid
+ [ -n "$circuitid" ] || return 0
+
+ append args "--dhcp-circuitid=$name,$circuitid"
+
+ dhcp_option_add "$cfg" "$name"
+}
+
+dhcp_userclass_add() {
+ local cfg="$1"
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || return 0
+
+ config_get userclass "$cfg" userclass
+ [ -n "$userclass" ] || return 0
+
+ append args "--dhcp-userclass=$name,$userclass"
+
+ dhcp_option_add "$cfg" "$name"
+}
+
+dhcp_vendorclass_add() {
+ local cfg="$1"
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || return 0
+
+ config_get vendorclass "$cfg" vendorclass
+ [ -n "$vendorclass" ] || return 0
+
+ append args "--dhcp-vendorclass=$name,$vendorclass"
+
+ dhcp_option_add "$cfg" "$name"
+}
+
+dhcp_host_add() {
+ local cfg="$1"
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || return 0
+
+ config_get mac "$cfg" mac
+ [ -n "$mac" ] || return 0
+
+ config_get ip "$cfg" ip
+ [ -n "$ip" ] || return 0
+
+ append args "--dhcp-host=$mac,$ip"
+
+ dhcp_option_add "$cfg" "$name"
+}
+
+dhcp_mac_add() {
+ local cfg="$1"
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || return 0
+
+ config_get mac "$cfg" mac
+ [ -n "$mac" ] || return 0
+
+ append args "--dhcp-mac=$name,$mac"
+
+ dhcp_option_add "$cfg" "$name"
+}
+
+dhcp_boot_add() {
+ local cfg="$1"
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || return 0
+
+ config_get filename "$cfg" filename
+ [ -n "$filename" ] || return 0
+
+ config_get servername "$cfg" servername
+ [ -n "$servername" ] || return 0
+
+ config_get serveraddress "$cfg" serveraddress
+ [ -n "$serveraddress" ] || return 0
+
+ append args "--dhcp-boot=net:$name,$filename,$servername,$serveraddress"
+
+ dhcp_option_add "$cfg" "$name"
+}
+
+
+dhcp_add() {
+ local cfg="$1"
+ config_get net "$cfg" interface
+ [ -n "$net" ] || return 0
+
+ config_get name "$cfg" name
+ [ -n "$name" ] || name="$net"
+
+ config_get ifname "$net" ifname
+ [ -n "$ifname" ] || return 0
+
+ config_get dnsserver "$net" dns
+ [ -n "$dnsserver" ] && {
+ DNS_SERVERS="$DNS_SERVERS $dnsserver"